{%- import "src/_rda_template.j2" as rda_dmp_cs with context -%}
{%- import "src/_utils.j2" as utils with context -%}
{%- import "src/_tree_utils.j2" as tree with context -%}

{#- ------------------------------------------------------------  -#}
{#- globals to THIS file, which we call locals... -#}
{#- ------------------------------------------------------------  -#}
{#- variables global to this file, not meant to be used by the caller  -#}

{%- set local_ns = namespace(description="dmp_general") -%}

{%- set local_ns.dmp_id_root = none -%}
{%- set local_ns.dmp_id_types = ["handle", "doi", "ark", "url", "other"] -%}


{%- macro createDMPId(globals, dmp_being_built, uuid) -%}
  {#- only one identifier allowed -#}
  {#- in RDA RDA_DMP_CS as in our KM -#}
  {#- -#}
  {#- we test this by checking the length of dmp_id -#}
  
  {%- if dmp_being_built.dmp_id|length == 0 -%}
    {{ utils.deepCopy(rda_dmp_cs.dmp_id) }}
    {%- set obj = utils.global_ns.var_stack.pop() -%} 
    {%- do dmp_being_built.update({ "dmp_id" : obj }) -%}

    {%- set local_ns.dmp_id_root = uuid -%}
  {%- else -%}
    {{ utils.warningMessage(false, "in createDMPId, there can be only one identifier") }}
  {%- endif -%}
{%- endmacro -%}

{%- macro setDMPIdType(globals, dmp_being_built, reply, uuid) -%}

  {#- the check below is strictly speaking not necessary as -#}
  {#- only one id is permitted -#}
  {#- and the annotation DMPIdType is dependant on annotation DMPId -#}
  {{ tree.isChildOf(globals, uuid, local_ns.dmp_id_root) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}

  {%- if answer -%}
    {%- if reply|lower in local_ns.dmp_id_types -%}
      {%- do dmp_being_built.dmp_id.update({ "type" : reply|lower }) -%}
    {%- else -%}
      {%- do dmp_being_built.dmp_id.update({ "type" : "other" }) -%}
    {%- endif -%}
  {%- endif -%}

{%- endmacro -%}

{%- macro setDMPIdIdentifier(globals, dmp_being_built, reply, uuid) -%}
  {#- the check below is strictly speaking not necessary as -#}
  {#- only one id is permitted -#}
  {#- and the annotation DMPIdIdentifier is dependant on annotation DMPId -#}
  {{ tree.isChildOf(globals, uuid, local_ns.dmp_id_root) }}
  {%- set answer = tree.global_ns.var_stack.pop() -%}
  {%- if answer -%}
    {%- do dmp_being_built.dmp_id.update({ "identifier" : reply }) -%}
  {%- endif -%}
 
{%- endmacro -%}
